package gbaMus;
import java.io.*;

/* GBAMusMerger (c) 2012 by Bregalad
 * 
 * This extra program is able to insert the music of most GBA games
 * into all Final Fantasy Advance ROMs so that you can use their cool music player
 * 
 * This program is slow, buggy and unfinished though.
 */

public class GBAMusMerger {

	public static void main(String[] args) {
		System.out.println("GBA ROM music merger (c) 2009 Bregalad\n");
		if (args.length<2 || args.length>4) {
			System.out.println("Invalid argument list! Format :");
			System.out.println("GBAMusMerger pathname ROM-number [offset] [table-address]");
			System.out.println("Where \"table-adress\" is the hex adress of the music table in the new ROM");
			System.out.println("ROM number indicate in which Final Fantasy Advance ROM the music is inserted:");
			System.out.println("0 = Final Fantasy 1&2 (E)");
			System.out.println("1 = Final Fantasy IV Advance (E)");
			System.out.println("2 = Final Fantasy V Advance (E)");
			System.out.println("3 = Final Fantasy VI Advance (E)");
			System.out.println("4 = Final Fantasy 1&2 (U)");
			System.out.println("5 = Final Fantasy IV Advance (U) (don't work)");
			System.out.println("6 = Final Fantasy V Advance (U) (don't work)");
			System.out.println("7 = Final Fantasy VI Advance (U)");
			System.exit(-1);
		}
		//Size of all Final Fantasy Advance ROMs
		final int[] FileSizeList = {0x1000000, 0x800000, 0x1000000, 0x1000000, 0x1000000, 0x800000, 0x800000, 0x800000};
		//Location of main song table of ROMs (unused)
		final int[] SongMainTblList = {0x974660, 0x4f5a5c, 0x540620, 0x16f41c, 0x8d3058, 0x3dc894, 0x3f2cb4, 0x1c6a94};
		//Location of music player song table
		final int[] SongTbl1List = {0x35c730, 0xd86a0, 0x134150, 0x162b0c, 0x29708c, 0x43af4, 0x11b59c, 0x160b10};
		//Location of secondary song table (not used)
		final int[] SongTbl2List = {0x1d77cc, 0xcc804, 0x11c98c, 0, 0, 0xc9770, 0, 0};
		//Size of the main song table
		final int[] SongMainTblSizeList = {717, 221, 290, 371, 717, 221, 290, 371};
		//Size of the music player song table
		final int[] SongTbl1SizeList = {62, 46, 68, 75, 62, 58, 79, 75};
		//Size of the secondary songt table (not used)
		final int[] SongTbl2SizeList = {62, 58, 79, 0, 0, 30, 0, 0};
		//Location of main parameters
		final int[] MainParameters = {0x191a88, 0xbd70c, 0x101c94, 0x134a0c, 0x18abe0, 0xba6e8, 0x100490, 0x13324c};
		//Lockup table for GBA sampling rates
		final String[] Freq = {"invalid", "5734 Hz", "7884 Hz", "10512 Hz", "13379 Hz", "15768 Hz", "18157 Hz",
				"21024 Hz", "26758 Hz", "31536 Hz", "36314 Hz", "40137 Hz", "42048 Hz", "invalid", "invalid", "invalid"};

		int ROMIndex = Integer.parseInt(args[1]);					//Get index of the ROM used

		final int OldFileSize = FileSizeList[ROMIndex];
		final int SongMainTbl = SongMainTblList[ROMIndex];
		final int SongTbl1 = SongTbl1List[ROMIndex];
		final int SongTbl2 = SongTbl2List[ROMIndex];
		final int SongMainTblSize = SongMainTblSizeList[ROMIndex];
		final int SongTbl1Size = SongTbl1SizeList[ROMIndex];
		final int SongTbl2Size = SongTbl2SizeList[ROMIndex];
		
		String path=(args[0]);							//Store pathname of the file to fix pointers

		try {
			java.io.RandomAccessFile raf = new java.io.RandomAccessFile(path, "rw");	//Open the file
			System.out.println("File size : 0x" + Long.toHexString(raf.length()));
			final int NewFileSize = (int)raf.length()-OldFileSize;			//Compute size of the external ROM
			int NewSongTbl = 0;
			boolean detected = false;

			int p1 = 0, p2 = 0, data, dummy, offset;
			
			if(args.length>2)
				offset = Integer.parseInt(args[2]);
			else offset=0;
			
			if(args.length>3) {
				NewSongTbl = Integer.parseInt(args[3], 16);	//Manual input for address of the song table
				detected = true;
			}
			
						//This fixes all aligned pointers
			for(int i=OldFileSize; i<raf.length()-4; i+=4) {
				raf.seek(i);
				data = Integer.reverseBytes(raf.readInt());		//Convert to big endian format used by java
				if(data>=0x8000000 && data <(0x8000000 | NewFileSize)) {	//Check if the int read is a ROM pointer
					raf.seek(i-4);
					dummy = raf.readInt();						//Make sure the "pointer" is not a pitch indication
					if(dummy != 0x40) {
						raf.seek(i);
						raf.writeInt(Integer.reverseBytes(data + OldFileSize));		//Add the main offset to the data
						p1++;		
					}
				}
				else if (!detected && ((data == 0x4700bc01)||(data == 0x4700))) {			//Check for sound code
						raf.seek(i-4);
						dummy = raf.readInt();
						if (dummy == 0xf1d170bc || dummy == 0xf0bc01bc) {
							raf.seek(i-8);
							dummy = raf.readInt();
							if (dummy == 0x13e002e || dummy == 0x08bc9846) {
								raf.seek(i+12);
								dummy = raf.readInt();
								if(dummy == 0x10004) System.out.println("Sound engine detected : Stereo version");
								else if(dummy == 0xe0000004) System.out.println("Sound engine detected : Mono version");
								else continue; //System.out.println("Unknown / other version");
								raf.seek(i+24);
								dummy = raf.readInt();
								if(dummy==0) continue;
								System.out.print("Engine parameters : ");
								System.out.print("Main Volume : " + ((dummy & 0xF00000)>>20) );
								System.out.print(", Polyphony : " +((dummy & 0xF0000)>>16) + " channels");
								System.out.print(", Dac : " + (17-((dummy & 0xF000)>>12)) + " bits");
								System.out.print(", Sampling rate : " + Freq[((dummy &0xF00)>>8)] );
								System.out.println(", Echo Feedback: " + (dummy&0x7F));
								raf.seek(MainParameters[ROMIndex]);
								raf.writeInt(dummy);							//Overwrite main parameters
								raf.seek(i+28);
								dummy = Integer.reverseBytes(raf.readInt());	//Read # of song levels
								raf.seek(i+32);
								NewSongTbl = (Integer.reverseBytes(raf.readInt())&0x3FFFFFF) + 12*dummy;		//compute address of song table
								System.out.println("Song table located at : 0x" + Integer.toHexString(NewSongTbl));
								detected = true;
							}
						}
				}
				if ((i&0x7FFFF)==0) System.out.print(".");
			}
			if(!detected) {			//If no address were told manually and nothing was detected....
				System.out.println("Automatic song table detection failed. Please find manually adress of the song table.");
				System.exit(-1);
			}

			System.out.println(p1 + " aligned pointers adjusted");
			byte cmd;			//This loop fixes all non-aligned pointers after a jmp or call music command
		  	for(int i=OldFileSize; i<raf.length(); i++) {
				raf.seek(i);
				cmd = raf.readByte();					//Read a byte
				if(cmd == -78 || cmd == -77) {			//Detect possible "jump" and "call" commands
					raf.seek(i+1);							//Read the argument
					data = raf.readInt();
					data = Integer.reverseBytes(data);					//Convert to big endian format used by java
					if(data>=0x8000000 && data <(0x8000000|NewFileSize)) {		//Check if the int read is a ROM pointer
						raf.seek(i+1);
						raf.writeInt(Integer.reverseBytes(data + OldFileSize));		//If so add the main offset to the data
						i+=4;
						p2++;
					}
				}
				if ((i&0x7FFFF)==0) System.out.print(".");
			}
			System.out.println(p2 + " unaligned pointers adjusted");
			
			System.out.println("Overwriting song table...");

			for(int i=0; i<SongTbl1Size; i++) {
				raf.seek(NewSongTbl+((i+offset)<<3) + OldFileSize);
				data = raf.readInt();
				raf.seek(SongTbl1+12*i);
				raf.writeInt(data);			//Write the new pointers for table 1
			}
/*			for(int i=0; i<SongTbl2Size; i++) {
				raf.seek(OldFileSize|NewSongTbl+(i<<3));
				data = raf.readInt();
				raf.seek(SongTbl2+12*i);
				raf.writeInt(data);			//Write the new pointers for table 2
			}		*/
			System.out.println("Done !");
			raf.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
